<template>
  <div>
    <div class="el-card_top">
      <el-form :inline="true" :model="formInline" class="demo-form-inline">
        <!-- <el-form-item label="公司" prop="companyName">
          <company-info-selector
            v-model="formInline.companyName"
            :valueName="formInline.companyIds"
            @handleChanged="handleChanged"
            @value="companyValue"
          />
        </el-form-item> -->
        <el-form-item label="路段" prop="roadSegmentName">
          <router-info-selector
            v-model="formInline.roadSegmentId"
            :value="formInline.roadSegmentId"
            @changed="changed"
            @value="value"
          />
        </el-form-item>
        <el-form-item label="检查类别" prop="type">
          <dict-select
            dictCode="xjlb"
            :hasDefaultOption="true"
            v-model="formInline.type"
            style="width: 100%"
          />
        </el-form-item>
        <el-form-item label="巡检查日期">
          <el-date-picker
            v-model="formInline.startDate"
            type="date"
            width="100%"
            placeholder="开始日期"
            value-format="yyyy-MM-dd"
          >
          </el-date-picker>
          <el-date-picker
            v-model="formInline.endDate"
            type="date"
            width="100%"
            placeholder="结束日期"
            value-format="yyyy-MM-dd"
            style="margin-left: 10px"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="onSubmit" icon="el-icon-search"
            >查询</el-button
          >
        </el-form-item>
        <el-form-item>
          <!-- <el-button @click="onSubmit">重置</el-button> -->
        </el-form-item>
      </el-form>
      <!-- <road-info-dialog
        ref="road"
        :single="true"
        @select="handleSelectRoad"
      ></road-info-dialog> -->
    </div>
    <el-card class="box-card">
      <div class="item">
        <div id="main_1" :style="{width: '300px', height: '300px'}"></div>
        <div id="main_2" :style="{width: '300px', height: '300px'}"></div>
      </div>
    </el-card>
    <el-card style="height: calc(100% - 480px)">
      <div class="item">
        <div id="main_3" :style="{width: '300px', height: '300px'}"></div>
        <div id="main_4" :style="{width: '300px', height: '300px'}"></div>
      </div>
    </el-card>
  </div>
</template>

<script>
import * as echarts from 'echarts'
import eipOrgSelector from '@/components/eipControl/selector/EipOrgSelector.vue'
import RoadInfoDialog from '@/components/dialog/RoadInfoDialog.vue'
import routerInfoSelector from '@/components/selector/routerInfoSelector.vue'
export default {
  components: {
    eipOrgSelector,
    RoadInfoDialog,
    routerInfoSelector,
  },
  data() {
    return {
      formInline: {
        companyName: '',
        roadSegmentName: '',
      },
    }
  },
  mounted() {
    this.load()
    // this.getEcharts()
  },
  methods: {
    load() {
      let params = {}
      this.$http
        .post('${yhxt}/statisticalStatement/v1/countDisease', params)
        .then((res) => {
          console.log(res, '道路统计')
          this.getEcharts(res.data)
        })
    },
    //公司赋值
    handleChanged(obj) {
      // console.log(obj.valueInfo.join(','))
      this.formInline.companyIds = JSON.stringify(obj.valueInfo)
      this.formInline.companyName = obj.name
      this.formInline.companyId = obj.id
    },
    companyValue(obj) {
      // console.log(obj)
      this.formInline.companyName = obj.name
      this.formInline.companyId = obj.id
      this.formInline.companyIds = JSON.stringify(obj.id.split(' ')) //必须是空格
    },
    onSubmit() {
      console.log('submit!')
    },
    //选取路线回填数据
    handleSelectRoad(data) {
      // console.log(data.name, '路线信息')
      // this.formInline.roadSegmentName = data.name
      // this.formInline.roadSegmentId = data.id
    },
    //路线信息赋值
    changed(obj) {
      // console.log(obj)
      this.formInline.roadSegmentName = obj.name
      this.formInline.roadSegmentId = obj.id
    },
    value(obj) {
      console.log(obj)
      this.formInline.roadSegmentName = obj.name
      this.formInline.roadSegmentId = obj.id
    },
    getEcharts(data) {
      let chartDom_1 = document.getElementById('main_1')
      let chartDom_2 = document.getElementById('main_2')
      let chartDom_3 = document.getElementById('main_3')
      let chartDom_4 = document.getElementById('main_4')
      let myChart_1 = echarts.init(chartDom_1)
      let myChart_2 = echarts.init(chartDom_2)
      let myChart_3 = echarts.init(chartDom_3)
      let myChart_4 = echarts.init(chartDom_4)
      let publicOption = {
        tooltip: {
          trigger: 'item',
        },
        // legend: {
        //   orient: 'vertical',
        //   bottom: 'bottom',
        //   // itemWidth: 25,
        //    textStyle: {
        //     color: '#fff'
        //   }
        // },
      }
      console.log(data)
      let porttype = [
        {key: 'diseaseDay', name: '日巡检'},
        {key: 'diseaseNight', name: '夜巡检'},
        {key: 'diseaseBridgeOften', name: '桥梁经常检查'},
        {key: 'diseaseTunnelOften', name: '隧道经常检查'},
        {key: 'diseaseCulvertOften', name: '涵洞经常检查'},
        {key: 'diseaseSideSlopeOften', name: '边坡经常检查'},
        {key: 'diseaseBridgeRegular', name: '桥梁定期检查'},
        {key: 'diseaseTunnelRegular', name: '隧道定期检查'},
        {key: ' diseaseCulvertRegular', name: '涵洞定期检查'},
        {key: 'diseaseSideSlopeRegular', name: '边坡定期检查'},
      ]
      let arr1 = this.transformation(data.diseaseCategory,porttype)
      console.log(arr1)
      // arr1.forEach(item=>{
      //   item['日巡检']=item.diseaseDay
      // })
      let option_1 = {
        title: {
          text: '检测类别统计',
          left: 'center',
          textStyle: {
            color: '#fff',
          },
        },
        series: [
          {
            name: '检测类别统计',
            type: 'pie',
            radius: '50%',
            data: arr1,
            label: {
              color: '#fff',
            },
            emphasis: {
              itemStyle: {
                shadowBlur: 10,
                shadowOffsetX: 0,
                shadowColor: 'rgba(0, 0, 0, 0.5)',
              },
            },
          },
        ],
        ...publicOption,
      }
      let Disposal = [
        {key: 'handlingSituationNo', name: '未处理'},
        {key: 'handlingSituationRun', name: '处理中'},
        {key: 'handlingSituationYes', name: '已处理'},
        {key: 'handlingSituationObserve', name: '观察记录'},
      ]
      let arr2 = this.transformation(data.diseaseHandlingSituation,Disposal)
      let option_2 = {
        title: {
          text: '处置情况统计',
          left: 'center',
          textStyle: {
            color: '#fff',
          },
        },
        series: [
          {
            name: '处置情况统计',
            type: 'pie',
            radius: '50%',
            data: arr2,
            label: {
              color: '#fff',
            },
            emphasis: {
              itemStyle: {
                shadowBlur: 10,
                shadowOffsetX: 0,
                shadowColor: 'rgba(0, 0, 0, 0.5)',
              },
            },
          },
        ],
        ...publicOption,
      }
      let arr3 = []
      for (let i in data.subject) {
        // console.log(i, data.diseaseCategory[i])
        let o = {}
        o['name'] = i
        o['value'] = data.subject[i]
        arr3.push(o)
      }
      let option_3 = {
        title: {
          text: '病害类别统计',
          left: 'center',
          textStyle: {
            color: '#fff',
          },
        },
        series: [
          {
            name: '病害类别统计',
            type: 'pie',
            radius: '50%',
            data: arr3,
            label: {
              color: '#fff',
            },
            emphasis: {
              itemStyle: {
                shadowBlur: 10,
                shadowOffsetX: 0,
                shadowColor: 'rgba(0, 0, 0, 0.5)',
              },
            },
          },
        ],
        ...publicOption,
      }
      let positions=[
        {key: 'diseasePositionRamp', name: '匝道'},
        {key: 'diseasePositionTollGate', name: '收费站'},
        {key: 'diseasePositionCoverage', name: '服务区'},
        {key: 'diseasePositionManageStation', name: '管理站房'},
        {key: 'diseasePositionOther', name: '其他'},
      ]
      let arr4 = this.transformation(data.diseasePosition,positions)
      let option_4 = {
        title: {
          text: '病害部位统计',
          left: 'center',
          textStyle: {
            color: '#fff',
          },
        },
        series: [
          {
            name: '病害部位统计13',
            type: 'pie',
            radius: '50%',
            data: arr4,
            label: {
              color: '#fff',
            },
            emphasis: {
              itemStyle: {
                shadowBlur: 10,
                shadowOffsetX: 0,
                shadowColor: 'rgba(0, 0, 0, 0.5)',
              },
            },
          },
        ],
        ...publicOption,
      }
      option_1 && myChart_1.setOption(option_1)
      option_2 && myChart_2.setOption(option_2)
      option_3 && myChart_3.setOption(option_3)
      option_4 && myChart_4.setOption(option_4)
    },
    transformation(data, arr) {
      let arr1 = []
      for (let i in data) {
        // console.log(i, data[i])
        let o = {}
        o['name'] = i
        o['value'] = data[i]
        for (let j in arr) {
          // console.log(arr1[j], j, o)
          if (arr[j].key == o.name) {
            o.name = arr[j].name
            arr1.push(o)
          }
        }
      }
      return arr1
    },
  },
}
</script>

<style lang='scss' scoped>
.el-form {
  margin-top: 8px;
  margin-left: 10px;
}
.el-card {
  margin: 10px;
}
/deep/.box-card {
  margin: 0 10px;
  height: calc(100% - 480px);
  overflow: auto;
}
.item {
  display: flex;
  justify-content: space-evenly;
  flex-wrap: wrap;
}
.el-card_top {
  height: 50px;
  margin: 10px;
  border-radius: 4px;
  border: 1px solid #113556;
  background-color: #103c5d !important;
  overflow: hidden;
  color: #303133;
  transition: 0.3s;
  box-shadow: 0 2px 12px #eee;
}
.box-bottom {
  margin: 0 10px;
  height: 280px;
  overflow: auto;
}
/deep/ .el-select__tags[data-v-2f5be1c8] {
  margin-top: 1px;
}
/* 设置滚动条的样式 */
/deep/ ::-webkit-scrollbar {
  width: 8px;
  background-color: #fff;
}

/* 滚动槽 */
/deep/ ::-webkit-scrollbar-track {
  border-radius: 8px;
}

/* 滚动条滑块 */
/deep/ ::-webkit-scrollbar-thumb {
  border-radius: 8px;
  background: #eee;
}
</style>